/*
 * program to print out dates of the files named in argv[]
 * in a format that is human readable and can be fed to sort
 */

#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>


char *format = "%Y.%m.%d";

int
filedate (s)
char *s;
{
    struct stat buf;
    struct tm *tm;
    char datebuf[1024];

    if (stat (s, &buf) >= 0) {
	tm = localtime (&buf.st_mtime);
#if 1
	strftime (datebuf, sizeof (datebuf), format, tm);
	printf ("%s %s\n", datebuf, s);
#else
	printf ("%04d.%02d.%02d %s\n", tm->tm_year+1900, 
		tm->tm_mon+1, tm->tm_mday, s);
#endif
    }
}

main (argc, argv)
int argc;
char **argv;
{
    int i;

    if (argc > 1 && *argv[1] == '+') {
	format = argv[1] + 1;
	--argc;
	++argv;
    }

    for (i=1; i < argc; ++i)
	filedate (argv[i]);
}

